//
// Created by zx on 2021/8/6.
//

#ifndef ROBOT_CONTROL_FEATURE_EXTRA_SRC_SHUTTLER_VERIFIER_H_
#define ROBOT_CONTROL_FEATURE_EXTRA_SRC_SHUTTLER_VERIFIER_H_

#include <iostream>
#include <pcl/point_types.h>
#include <pcl/point_cloud.h>
#include <pcl/io/pcd_io.h>
#include <opencv2/opencv.hpp>
#include <mutex>
#include "error_code.h"
#include <pcl/visualization/pcl_visualizer.h>

class shuttler_verifier
{

 public:
    shuttler_verifier();
    ~shuttler_verifier();
    shuttler_verifier(const shuttler_verifier& shutter)= default;
    shuttler_verifier& operator=(const shuttler_verifier& shutter);

    void set_condition(Eigen::Vector4f plane,float maxd,float mind);

    Error_manager verify(pcl::PointCloud<pcl::PointXYZ>::Ptr cloud);

    void create_plane(pcl::visualization::PCLVisualizer& viewer);

 protected:
    bool pointInRectangle(pcl::PointXYZ point);
 private:

    std::mutex              m_mutex;

    float                   m_maxd;
    float                   m_mind;

    Eigen::Vector4f         m_plane;    //平面法向量

};


#endif //ROBOT_CONTROL_FEATURE_EXTRA_SRC_SHUTTLER_VERIFIER_H_
